Component({
  properties: {
    open: {
      type: Boolean,
      value: false,
    },
  },
  data: {
    dialpadIcon: 'https://imgcache.qq.com/operation/dianshi/other/dialpad.3e567438254523125d048e3c042f2a88260eea28.png',
    digits: '123456789*0#'.split(''),
    rippleSet: '123456789*0#'.split('').reduce(
      (acc, cur) => ({
        [cur]: false,
        ...acc,
      }),
      {},
    ),
  },
  methods: {
    triggerOpen() {
      this.triggerEvent('open');
    },
    triggerRipple(event) {
      this.setData({
        rippleSet: {
          ...this.data.rippleSet,
          [event.target.dataset.digit]: true,
        },
      });
      this.triggerEvent('digit', event.target.dataset.digit);
    },
    cancelRipple(event) {
      this.setData({
        rippleSet: {
          ...this.data.rippleSet,
          [event.target.dataset.digit]: false,
        },
      });
    },
  },
});
