export class DigitsConsumer {
  constructor(send) {
    this.loading = false;
    this.digits = [];
    this.send = send;
  }

  start(digit) {
    this.digits.push(digit);
    if (this.loading) return;
    this.requestNext().then((r) => r);
  }

  async request(digit) {
    try {
      const { errorCode } = await this.send?.(digit);
      if (errorCode === '0') {
      } else {
        this.digits = [];
      }
    } catch (e) {
      this.digits = [];
    }
  }

  async requestNext() {
    this.loading = true;
    if (this.digits.length > 0) {
      const digit = this.digits.shift();
      if (digit) {
        await this.request(digit);
        await this.requestNext();
      }
    } else {
      this.loading = false;
    }
  }
}
