import { checkLogin, login } from 'tccc-wx-sdk/login';
import { SDKAPPID as sdkAppId } from '../../config';
Page({
  data: {
    title: '腾讯云呼叫中心',
    getPhoneNumber: true,
    getUserInfo: true,
    hasLogin: false,
    jsCode: '',
    dataEnc: '',
    dataIv: '',
    dialogOpen: false,
    sdkAppId: '',
  },
  onLoad() {
    checkLogin().then((res) => {
      this.setData({
        hasLogin: res,
        sdkAppId,
      });
      if (!res) {
        wx.login({}).then(({ code }) => {
          this.setData({
            jsCode: code,
          });
        });
      }
    });
  },
  async dispatchLogin() {
    let dataEnc = '';
    let dataIv = '';
    if (this.data.getUserInfo) {
      try {
        const userProfileRes = await wx.getUserProfile({
          desc: '用于授权信息',
        });
        dataEnc = userProfileRes.encryptedData;
        dataIv = userProfileRes.iv;
      } catch (e) {
        console.warn('授权信息失败');
      }
    }
    if (this.data.getPhoneNumber && dataEnc && dataIv) {
      this.setData({
        dialogOpen: true,
        dataEnc,
        dataIv,
      });
      return;
    }
    this.tcccLogin({
      jsCode: this.data.jsCode,
      sdkAppId: this.data.sdkAppId,
      dataEnc,
      dataIv,
    });
  },
  loginAndGetPhoneNumber(e) {
    const {
      detail: { encryptedData: mobileEnc, iv: mobileIv },
    } = e;
    this.setData({
      dialogOpen: false,
    });
    this.tcccLogin({
      jsCode: this.data.jsCode,
      sdkAppId: this.data.sdkAppId,
      dataEnc: this.data.dataEnc,
      dataIv: this.data.dataIv,
      mobileEnc,
      mobileIv,
    });
  },
  async tcccLogin(params) {
    if (!params.jsCode) {
    }
    try {
      await login(params);
      this.handleLoginSuccess();
      return true;
    } catch (e) {
      try {
        const { code } = await wx.login();
        await login({
          ...params,
          jsCode: code,
        });
        this.handleLoginSuccess();
        return true;
      } catch (e) {
        wx.showToast({
          icon: 'error',
          title: e?.message || '登录失败',
        });
      }
      return false;
    }
  },
  async directlyCall() {
    const { code } = await wx.login();
    await this.tcccLogin({
      jsCode: code,
      sdkAppId: this.data.sdkAppId,
    });
    this.toCall();
  },
  handleLoginSuccess() {
    wx.showToast({
      title: '登录成功',
      success: () => {
        this.setData({
          hasLogin: true,
        });
      },
    });
  },
  handleCancel() {
    this.setData(
      {
        dialogOpen: false,
      },
      () => {
        this.tcccLogin({
          jsCode: this.data.jsCode,
          dataEnc: this.data.dataEnc,
          dataIv: this.data.dataIv,
          sdkAppId: this.data.sdkAppId,
        });
      },
    );
  },
  toCall() {
    wx.navigateTo({
      url: '/pages/call/call',
    });
  },
});
